'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var configs = require('../../../lib/configs');
var log = require('../../../lib/utils/log');
var helper = require('../../../lib/utils/helper');
var Package = require('../../../lib/utils/package');

module.exports = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(packages, options) {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, pkg, data;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!packages || !packages.length) packages = [configs.pkgName];

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 4;
                        _iterator = helper.aliasNames(packages)[Symbol.iterator]();

                    case 6:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context.next = 15;
                            break;
                        }

                        pkg = _step.value;
                        _context.next = 10;
                        return Package.getInfo(pkg, options.tag);

                    case 10:
                        data = _context.sent;


                        if (data && data.version) {
                            log.cyan(`${pkg}@${data.version}`);
                        } else {
                            log.yellow(`找不到 ${pkg}@${options.tag}`);
                        }

                    case 12:
                        _iteratorNormalCompletion = true;
                        _context.next = 6;
                        break;

                    case 15:
                        _context.next = 21;
                        break;

                    case 17:
                        _context.prev = 17;
                        _context.t0 = _context['catch'](4);
                        _didIteratorError = true;
                        _iteratorError = _context.t0;

                    case 21:
                        _context.prev = 21;
                        _context.prev = 22;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 24:
                        _context.prev = 24;

                        if (!_didIteratorError) {
                            _context.next = 27;
                            break;
                        }

                        throw _iteratorError;

                    case 27:
                        return _context.finish(24);

                    case 28:
                        return _context.finish(21);

                    case 29:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[4, 17, 21, 29], [22,, 24, 28]]);
    }));

    return function (_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();