'use strict';

var npm = require('../../../lib/utils/npm');
var yarn = require('../../../lib/utils/yarn');
var helper = require('../../../lib/utils/helper');

module.exports = function () {
    var packages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    packages = helper.aliasNames(packages);

    if (yarn.isUseYarn(options)) {
        yarn.update(packages, options);
    } else {
        npm.update(packages, options);
    }
};